//!
//! # Consume Handler
//!
//! Output Type defines the types of consume output allowed.
//!

// -----------------------------------
// Consumer Output Types
// -----------------------------------

use structopt::clap::arg_enum;

// Uses clap::arg_enum to choose possible variables
arg_enum! {
    #[derive(Debug, Clone, PartialEq)]
    #[allow(non_camel_case_types)]
    pub enum ConsumeOutputType {
        dynamic,
        text,
        binary,
        json,
        raw,
    }
}

/// Consume output type defaults to text formatting
impl ::std::default::Default for ConsumeOutputType {
    fn default() -> Self {
        ConsumeOutputType::dynamic
    }
}
